cdac.medinfo.sdk.hl7282.baselibs.segments

## Class CSR

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.CSR

- All Implemented Interfaces:
    ISegment

      public class CSR
      extends Segment

  CSR - Clinical Study Registration Segment.

  The CSR segment contains fundamental administrative and regulatory information required to document a patient's enrollment on a clinical trial. This segment is all that is required if one needs to message another system that an enrollment has taken place, i.e., from clinical trials to pharmacy, accounting or order entry systems.

  Represents an HL7 CSR message segment. This segment has the following fields:

  CSR-1: Sponsor Study ID (EI)Required
  CSR-2: Alternate Study ID (EI)Optional
  CSR-3: Institution Registering the Patient (CWE)Optional
  CSR-4: Sponsor Patient ID (CX)Required
  CSR-5: Alternate Patient ID - CSR (CX)Optional
  CSR-6: Date/Time Of Patient Study Registration (DTM)Required
  CSR-7: Person Performing Study Registration (XCN)Optional
  CSR-8: Study Authorizing Provider (XCN)Required
  CSR-9: Date/time Patient Study Consent Signed (DTM)Conditional
  CSR-10: Patient Study Eligibility Status (CWE)Conditional
  CSR-11: Study Randomization Date/time (DTM)Optional
  CSR-12: Randomized Study Arm (CWE)Optional
  CSR-13: Stratum for Study Randomization (CWE)Optional
  CSR-14: Patient Evaluability Status (CWE)Conditional
  CSR-15: Date/time Ended Study (DTM)Conditional
  CSR-16: Reason Ended Study (CWE)Conditional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CSR()` Constructs the CSR segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPersonPerformingStudyRegistration(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Add the Person Performing Study Registration.
    `void` | `addPersonPerformingStudyRegistration(XCN objpersonPerformingStudyRegistration)` Add the Person Performing Study Registration.
    `void` | `addRandomizedStudyArm(CWE objrandomizedStudyArm)` Add the Randomized Study Arm.
    `void` | `addRandomizedStudyArm(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Randomized Study Arm.
    `void` | `addStratumforStudyRandomization(CWE objstratumforStudyRandomization)` Add the Stratum for Study Randomization.
    `void` | `addStratumforStudyRandomization(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Stratum for Study Randomization.
    `void` | `addStudyAuthorizingProvider(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Add the Study Authorizing Provider.
    `void` | `addStudyAuthorizingProvider(XCN objstudyAuthorizingProvider)` Add the Study Authorizing Provider.
    `void` | `addStudyRandomizationDatetime(DTM studyRandomizationDatetime)` Add the Study Randomization Date time.
    `void` | `addStudyRandomizationDatetime(java.lang.String strTime)` Add the Study Randomization Date time.
    `CX` | `getAlternatePatientID_CSR()` Retrieves the Alternate Patient ID CSR.
    `EI` | `getAlternateStudyID()` Retrieves the Alternate Study ID.
    `DTM` | `getDatetimeEndedStudy()` Retrieves the Date time Ended Study.
    `DTM` | `getDateTimeOfPatientStudyRegistration()` Retrieves the Date Time Of Patient Study Registration.
    `DTM` | `getDatetimePatientStudyConsentSigned()` Retrieves the Date time Patient Study Consent Signed.
    `CWE` | `getInstitutionRegisteringthePatient()` Retrieves the Institution Registering the Patient.
    `CWE` | `getPatientEvaluabilityStatus()` Retrieves the Patient Evaluability Status.
    `CWE` | `getPatientStudyEligibilityStatus()` Retrieves the Patient Study Eligibility Status.
    `ISingleCollection<XCN>` | `getPersonPerformingStudyRegistration()` Retrieves the Person Performing Study Registration.
    `ISingleCollection<CWE>` | `getRandomizedStudyArm()` Retrieves the Randomized Study Arm.
    `CWE` | `getReasonEndedStudy()` Retrieves the Reason Ended Study.
    `CX` | `getSponsorPatientID()` Retrieves the Sponsor Patient ID.
    `EI` | `getSponsorStudyID()` Retrieves the Sponsor Study ID.
    `ISingleCollection<CWE>` | `getStratumforStudyRandomization()` Retrieves the Stratum for Study Randomization.
    `ISingleCollection<XCN>` | `getStudyAuthorizingProvider()` Retrieves the Study Authorizing Provider.
    `ISingleCollection<DTM>` | `getStudyRandomizationDatetime()` Retrieves the Study Randomization Date time.
    `void` | `setAlternatePatientID_CSR(CX objalternatePatientID_CSR)` Set the Alternate Patient ID CSR.
    `void` | `setAlternatePatientID_CSR(java.lang.String strIDNumber, java.lang.String strCheckDigit, java.lang.String strCheckDigitScheme, HD objAssigningAuthority, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepartment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the Alternate Patient ID CSR.
    `void` | `setAlternateStudyID(EI objalternateStudyID)` Set the Alternate Study ID.
    `void` | `setAlternateStudyID(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the Alternate Study ID.
    `void` | `setDatetimeEndedStudy(DTM objdatetimeEndedStudy)` Set the Date time Ended Study.
    `void` | `setDatetimeEndedStudy(java.lang.String strTime)` Set the Date time Ended Study.
    `void` | `setDateTimeOfPatientStudyRegistration(DTM objdateTimeOfPatientStudyRegistration)` Set the Date Time Of Patient Study Registration.
    `void` | `setDateTimeOfPatientStudyRegistration(java.lang.String strTime)` Set the Date Time Of Patient Study Registration.
    `void` | `setDatetimePatientStudyConsentSigned(DTM objdatetimePatientStudyConsentSigned)` Set the Date time Patient Study Consent Signed.
    `void` | `setDatetimePatientStudyConsentSigned(java.lang.String strTime)` Set the Date time Patient Study Consent Signed.
    `void` | `setInstitutionRegisteringthePatient(CWE objinstitutionRegisteringthePatient)` Set the Institution Registering the Patient.
    `void` | `setInstitutionRegisteringthePatient(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Institution Registering the Patient.
    `void` | `setPatientEvaluabilityStatus(CWE objpatientEvaluabilityStatus)` Set the Patient Evaluability Status.
    `void` | `setPatientEvaluabilityStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Patient Evaluability Status.
    `void` | `setPatientStudyEligibilityStatus(CWE objpatientStudyEligibilityStatus)` Set the Patient Study Eligibility Status.
    `void` | `setPatientStudyEligibilityStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Patient Study Eligibility Status.
    `void` | `setPersonPerformingStudyRegistration(ISingleCollection<XCN> objpersonPerformingStudyRegistrationList)` Set the Person Performing Study Registration.
    `void` | `setRandomizedStudyArm(ISingleCollection<CWE> objrandomizedStudyArmList)` Set the Randomized Study Arm.
    `void` | `setReasonEndedStudy(CWE objreasonEndedStudy)` Set the Reason Ended Study.
    `void` | `setReasonEndedStudy(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Reason Ended Study.
    `void` | `setSponsorPatientID(CX objsponsorPatientID)` Set the Sponsor Patient ID.
    `void` | `setSponsorPatientID(java.lang.String strIDNumber, java.lang.String strCheckDigit, java.lang.String strCheckDigitScheme, HD objAssigningAuthority, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepartment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the Sponsor Patient ID.
    `void` | `setSponsorStudyID(EI objsponsorStudyID)` Set the Sponsor Study ID.
    `void` | `setSponsorStudyID(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the Sponsor Study ID.
    `void` | `setStratumforStudyRandomization(ISingleCollection<CWE> objstratumforStudyRandomizationList)` Set the Stratum for Study Randomization.
    `void` | `setStudyAuthorizingProvider(ISingleCollection<XCN> objstudyAuthorizingProviderList)` Set the Study Authorizing Provider.
    `void` | `setStudyRandomizationDatetime(ISingleCollection<DTM> studyRandomizationDatetimeList)` Set the Study Randomization Date time.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CSR

          public CSR()

      Constructs the CSR segment.

  - ### Method Detail

    - #### getAlternatePatientID_CSR

          public CX getAlternatePatientID_CSR()

      Retrieves the Alternate Patient ID CSR. This field may be the sending application's patient identification.
      Returns:
        CX - alternatePatientID_CSR

    - #### getAlternateStudyID

          public EI getAlternateStudyID()

      Retrieves the Alternate Study ID. This field contains an alternate identifier that may be use as agreed upon by messaging parties.
      Returns:
        EI - alternateStudyID

    - #### getDatetimeEndedStudy

          public DTM getDatetimeEndedStudy()

      Retrieves the Date time Ended Study. This field contains the date of the patient completes or is otherwise remove from the study.
      Returns:
        DTM - datetimeEndedStudy

    - #### getDateTimeOfPatientStudyRegistration

          public DTM getDateTimeOfPatientStudyRegistration()

      Retrieves the Date Time Of Patient Study Registration. This field contains the healthcare facility employee who actually phoned, submitted a form, or interactively registered the patient on the clinical trial.
      Returns:
        DTM - dateTimeOfPatientStudyRegistration

    - #### getDatetimePatientStudyConsentSigned

          public DTM getDatetimePatientStudyConsentSigned()

      Retrieves the Date time Patient Study Consent Signed. This field contains the consent form signing date is collected to provide a checkpoint that the consent form is obtained.
      Returns:
        DTM - datetimePatientStudyConsentSigned

    - #### getInstitutionRegisteringthePatient

          public CWE getInstitutionRegisteringthePatient()

      Retrieves the Institution Registering the Patient. This field distinguishes the institution where registration occurred.
      Returns:
        CWE - institutionRegisteringthePatient

    - #### getPatientEvaluabilityStatus

          public CWE getPatientEvaluabilityStatus()

      Retrieves the Patient Evaluability Status. This field categorizes the inclusion of this patient's data for various analyses.
      Returns:
        CWE - patientEvaluabilityStatus

    - #### getPatientStudyEligibilityStatus

          public CWE getPatientStudyEligibilityStatus()

      Retrieves the Patient Study Eligibility Status. This field indicates whether the patient is an appropriate candidate for the trial or not.
      Returns:
        CWE - patientStudyEligibilityStatus

    - #### getPersonPerformingStudyRegistration

          public ISingleCollection<XCN> getPersonPerformingStudyRegistration()

      Retrieves the Person Performing Study Registration.
      Returns:
        ISingleCollection - personPerformingStudyRegistration

    - #### getRandomizedStudyArm

          public ISingleCollection<CWE> getRandomizedStudyArm()

      Retrieves the Randomized Study Arm. This field contains codes that must be developed by users.
      Returns:
        ISingleCollection - randomizedStudyArm

    - #### getReasonEndedStudy

          public CWE getReasonEndedStudy()

      Retrieves the Reason Ended Study.
      Returns:
        CWE - reasonEndedStudy

    - #### getSponsorPatientID

          public CX getSponsorPatientID()

      Retrieves the Sponsor Patient ID. This field contains the main patient identification for the study.
      Returns:
        CX - sponsorPatientID

    - #### getSponsorStudyID

          public EI getSponsorStudyID()

      Retrieves the Sponsor Study ID. This field contains the universal identifier for the clinical trial.
      Returns:
        EI - sponsorStudyID

    - #### getStratumforStudyRandomization

          public ISingleCollection<CWE> getStratumforStudyRandomization()

      Retrieves the Stratum for Study Randomization.
      Returns:
        ISingleCollection - stratumforStudyRandomization

    - #### getStudyAuthorizingProvider

          public ISingleCollection<XCN> getStudyAuthorizingProvider()

      Retrieves the Study Authorizing Provider. This field contains the healthcare provider, generally the attending physician, who is accountable that the patient is eligible for the trial and have signed an informed consent.
      Returns:
        ISingleCollection - studyAuthorizingProvider

    - #### getStudyRandomizationDatetime

          public ISingleCollection<DTM> getStudyRandomizationDatetime()

      Retrieves the Study Randomization Date time. This field contains the date the patient is randomize.
      Returns:
        ISingleCollection - studyRandomizationDatetime

    - #### setAlternatePatientID_CSR

          public void setAlternatePatientID_CSR(java.lang.String strIDNumber,
                                       java.lang.String strCheckDigit,
                                       java.lang.String strCheckDigitScheme,
                                       HD objAssigningAuthority,
                                       java.lang.String strIdentifierTypeCode,
                                       HD objAssigningFacility,
                                       java.lang.String strEffectiveDate,
                                       java.lang.String strExpirationDate,
                                       CWE objAssigningJurisdiction,
                                       CWE objAssigningAgencyOrDepartment,
                                       java.lang.String strSecurityCheck,
                                       java.lang.String strSecurityCheckScheme)

      Set the Alternate Patient ID CSR. This field may be the sending application's patient identification.
      Parameters:
        `strIDNumber` - Specifies the value of the identifier itself.
        `strCheckDigit` - It is part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Contains the code identifying the check digit scheme employed. Suggested Values NP,ISO,M10,M11.[Refer table No.0061].
        `objAssigningAuthority` - The assigning authority is a unique name of the system (or organization or agency or department) that creates the data. .
        `strIdentifierTypeCode` - Specifies a code corresponding to the type of identifier.In some cases, this code may be used as a qualifier to the "Assigning authority" component.[Refer table No 0203]
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the patient.
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepartment` - Specifies agency or department that assigned the identifier.

    - #### setAlternatePatientID_CSR

          public void setAlternatePatientID_CSR(CX objalternatePatientID_CSR)

      Set the Alternate Patient ID CSR. This field may be the sending application's patient identification.
      Parameters:
        `objalternatePatientID_CSR` - Object of Alternate Patient ID CSR.

    - #### setAlternateStudyID

          public void setAlternateStudyID(java.lang.String strEntityIdentifier,
                                 java.lang.String strNamespaceId,
                                 java.lang.String strUniversalId,
                                 java.lang.String strUniversalIdType)

      Set the Alternate Study ID. This field contains an alternate identifier that may be use as agreed upon by messaging parties.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setAlternateStudyID

          public void setAlternateStudyID(EI objalternateStudyID)

      Set the Alternate Study ID. This field contains an alternate identifier that may be use as agreed upon by messaging parties.
      Parameters:
        `objalternateStudyID` - Object of Alternate Study ID.

    - #### setDatetimeEndedStudy

          public void setDatetimeEndedStudy(java.lang.String strTime)

      Set the Date time Ended Study. This field contains the date of the patient completes or is otherwise remove from the study.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDatetimeEndedStudy

          public void setDatetimeEndedStudy(DTM objdatetimeEndedStudy)

      Set the Date time Ended Study. This field contains the date of the patient completes or is otherwise remove from the study.
      Parameters:
        `objdatetimeEndedStudy` - Object of Date time Ended Study.

    - #### setDateTimeOfPatientStudyRegistration

          public void setDateTimeOfPatientStudyRegistration(java.lang.String strTime)

      Set the Date Time Of Patient Study Registration. This field contains the healthcare facility employee who actually phoned, submitted a form, or interactively registered the patient on the clinical trial.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDateTimeOfPatientStudyRegistration

          public void setDateTimeOfPatientStudyRegistration(DTM objdateTimeOfPatientStudyRegistration)

      Set the Date Time Of Patient Study Registration. This field contains the healthcare facility employee who actually phoned, submitted a form, or interactively registered the patient on the clinical trial.
      Parameters:
        `objdateTimeOfPatientStudyRegistration` - Object of Date Time Of Patient Study Registration.

    - #### setDatetimePatientStudyConsentSigned

          public void setDatetimePatientStudyConsentSigned(java.lang.String strTime)

      Set the Date time Patient Study Consent Signed. This field contains the consent form signing date is collected to provide a checkpoint that the consent form is obtained.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setDatetimePatientStudyConsentSigned

          public void setDatetimePatientStudyConsentSigned(DTM objdatetimePatientStudyConsentSigned)

      Set the Date time Patient Study Consent Signed. This field contains the consent form signing date is collected to provide a checkpoint that the consent form is obtained.
      Parameters:
        `objdatetimePatientStudyConsentSigned` - Object of Date time Patient Study Consent Signed.

    - #### setInstitutionRegisteringthePatient

          public void setInstitutionRegisteringthePatient(java.lang.String strIdentifier,
                                                 java.lang.String strText,
                                                 java.lang.String strNameOfCodingSystem,
                                                 java.lang.String strAlternateIdentifier,
                                                 java.lang.String strAlternateText,
                                                 java.lang.String strNameOfAlternateCodingSystem,
                                                 java.lang.String strCodingSystemVersionID,
                                                 java.lang.String strAlternateCodingSystemVersionId,
                                                 java.lang.String strOriginalText,
                                                 java.lang.String strSecondAlternateIdentifier,
                                                 java.lang.String strSecondAlternateText,
                                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                                 java.lang.String strCodingSystemOID,
                                                 java.lang.String strValueSetOID,
                                                 java.lang.String strValueSetVersionID,
                                                 java.lang.String strAlternateCodingSystemOID,
                                                 java.lang.String strAlternateValueSetOID,
                                                 java.lang.String strAlternateValueSetVersionID,
                                                 java.lang.String strSecondAlternateCodingSystemOID,
                                                 java.lang.String strSecondAlternateValueSetOID,
                                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Institution Registering the Patient. This field distinguishes the institution where registration occurred.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setInstitutionRegisteringthePatient

          public void setInstitutionRegisteringthePatient(CWE objinstitutionRegisteringthePatient)

      Set the Institution Registering the Patient. This field distinguishes the institution where registration occurred.
      Parameters:
        `objinstitutionRegisteringthePatient` - Object of Institution Registering the Patient.

    - #### setPatientEvaluabilityStatus

          public void setPatientEvaluabilityStatus(java.lang.String strIdentifier,
                                          java.lang.String strText,
                                          java.lang.String strNameOfCodingSystem,
                                          java.lang.String strAlternateIdentifier,
                                          java.lang.String strAlternateText,
                                          java.lang.String strNameOfAlternateCodingSystem,
                                          java.lang.String strCodingSystemVersionID,
                                          java.lang.String strAlternateCodingSystemVersionId,
                                          java.lang.String strOriginalText,
                                          java.lang.String strSecondAlternateIdentifier,
                                          java.lang.String strSecondAlternateText,
                                          java.lang.String strNameofSecondAlternateCodingSystem,
                                          java.lang.String strSecondAlternateCodingSystemVersionID,
                                          java.lang.String strCodingSystemOID,
                                          java.lang.String strValueSetOID,
                                          java.lang.String strValueSetVersionID,
                                          java.lang.String strAlternateCodingSystemOID,
                                          java.lang.String strAlternateValueSetOID,
                                          java.lang.String strAlternateValueSetVersionID,
                                          java.lang.String strSecondAlternateCodingSystemOID,
                                          java.lang.String strSecondAlternateValueSetOID,
                                          java.lang.String strSecondAlternateValueSetVersionID)

      Set the Patient Evaluability Status. This field categorizes the inclusion of this patient's data for various analyses.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setPatientEvaluabilityStatus

          public void setPatientEvaluabilityStatus(CWE objpatientEvaluabilityStatus)

      Set the Patient Evaluability Status. This field categorizes the inclusion of this patient's data for various analyses.
      Parameters:
        `objpatientEvaluabilityStatus` - Object of Patient Evaluability Status.

    - #### setPatientStudyEligibilityStatus

          public void setPatientStudyEligibilityStatus(java.lang.String strIdentifier,
                                              java.lang.String strText,
                                              java.lang.String strNameOfCodingSystem,
                                              java.lang.String strAlternateIdentifier,
                                              java.lang.String strAlternateText,
                                              java.lang.String strNameOfAlternateCodingSystem,
                                              java.lang.String strCodingSystemVersionID,
                                              java.lang.String strAlternateCodingSystemVersionId,
                                              java.lang.String strOriginalText,
                                              java.lang.String strSecondAlternateIdentifier,
                                              java.lang.String strSecondAlternateText,
                                              java.lang.String strNameofSecondAlternateCodingSystem,
                                              java.lang.String strSecondAlternateCodingSystemVersionID,
                                              java.lang.String strCodingSystemOID,
                                              java.lang.String strValueSetOID,
                                              java.lang.String strValueSetVersionID,
                                              java.lang.String strAlternateCodingSystemOID,
                                              java.lang.String strAlternateValueSetOID,
                                              java.lang.String strAlternateValueSetVersionID,
                                              java.lang.String strSecondAlternateCodingSystemOID,
                                              java.lang.String strSecondAlternateValueSetOID,
                                              java.lang.String strSecondAlternateValueSetVersionID)

      Set the Patient Study Eligibility Status. This field indicates whether the patient is an appropriate candidate for the trial or not.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setPatientStudyEligibilityStatus

          public void setPatientStudyEligibilityStatus(CWE objpatientStudyEligibilityStatus)

      Set the Patient Study Eligibility Status. This field indicates whether the patient is an appropriate candidate for the trial or not.
      Parameters:
        `objpatientStudyEligibilityStatus` - Object of Patient Study Eligibility Status.

    - #### addPersonPerformingStudyRegistration

          public void addPersonPerformingStudyRegistration(java.lang.String strIDNumber,
                                                  FN objFamilyName,
                                                  java.lang.String strGivenName,
                                                  java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                                  java.lang.String strSuffix,
                                                  java.lang.String strPrefix,
                                                  CWE objSourceTable,
                                                  HD objAssigningAuthority,
                                                  java.lang.String strNameTypeCode,
                                                  java.lang.String strIdentifierCheckDigit,
                                                  java.lang.String strCheckDigitScheme,
                                                  java.lang.String strIdentifierTypeCode,
                                                  HD objAssigningFacility,
                                                  java.lang.String strNameRepresentationCode,
                                                  CWE objNameContext,
                                                  java.lang.String strNameAssemblyOrder,
                                                  java.lang.String strEffectiveDate,
                                                  java.lang.String strExpirationDate,
                                                  java.lang.String strProfessionalSuffix,
                                                  CWE objAssigningJurisdiction,
                                                  CWE objAssigningAgencyOrDepratment,
                                                  java.lang.String strSecurityCheck,
                                                  java.lang.String strSecurityCheckScheme)

      Add the Person Performing Study Registration. This field contains the healthcare facility employee who actually phoned, submitted a form, or interactively registered the patient on the clinical trial.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table.
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### addPersonPerformingStudyRegistration

          public void addPersonPerformingStudyRegistration(XCN objpersonPerformingStudyRegistration)

      Add the Person Performing Study Registration. This field contains the healthcare facility employee who actually phoned, submitted a form, or interactively registered the patient on the clinical trial.
      Parameters:
        `objpersonPerformingStudyRegistration` - Object of Person Performing Study Registration.

    - #### setPersonPerformingStudyRegistration

          public void setPersonPerformingStudyRegistration(ISingleCollection<XCN> objpersonPerformingStudyRegistrationList)

      Set the Person Performing Study Registration.
      Parameters:
        `objpersonPerformingStudyRegistrationList` - List of Person Performing Study Registration.

    - #### addRandomizedStudyArm

          public void addRandomizedStudyArm(java.lang.String strIdentifier,
                                   java.lang.String strText,
                                   java.lang.String strNameOfCodingSystem,
                                   java.lang.String strAlternateIdentifier,
                                   java.lang.String strAlternateText,
                                   java.lang.String strNameOfAlternateCodingSystem,
                                   java.lang.String strCodingSystemVersionID,
                                   java.lang.String strAlternateCodingSystemVersionId,
                                   java.lang.String strOriginalText,
                                   java.lang.String strSecondAlternateIdentifier,
                                   java.lang.String strSecondAlternateText,
                                   java.lang.String strNameofSecondAlternateCodingSystem,
                                   java.lang.String strSecondAlternateCodingSystemVersionID,
                                   java.lang.String strCodingSystemOID,
                                   java.lang.String strValueSetOID,
                                   java.lang.String strValueSetVersionID,
                                   java.lang.String strAlternateCodingSystemOID,
                                   java.lang.String strAlternateValueSetOID,
                                   java.lang.String strAlternateValueSetVersionID,
                                   java.lang.String strSecondAlternateCodingSystemOID,
                                   java.lang.String strSecondAlternateValueSetOID,
                                   java.lang.String strSecondAlternateValueSetVersionID)

      Add the Randomized Study Arm. This field contains codes that must be developed by users.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addRandomizedStudyArm

          public void addRandomizedStudyArm(CWE objrandomizedStudyArm)

      Add the Randomized Study Arm. This field contains codes that must be developed by users.
      Parameters:
        `objrandomizedStudyArm` - Object of Randomized Study Arm.

    - #### setRandomizedStudyArm

          public void setRandomizedStudyArm(ISingleCollection<CWE> objrandomizedStudyArmList)

      Set the Randomized Study Arm. This field contains codes that must be developed by users.
      Parameters:
        `objrandomizedStudyArmList` - List of Randomized Study Arm.

    - #### setReasonEndedStudy

          public void setReasonEndedStudy(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Reason Ended Study. This information is important for quality control and data analysis. The coding systems will vary among trials.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReasonEndedStudy

          public void setReasonEndedStudy(CWE objreasonEndedStudy)

      Set the Reason Ended Study.
      Parameters:
        `objreasonEndedStudy` - Object of Reason Ended Study.

    - #### setSponsorPatientID

          public void setSponsorPatientID(java.lang.String strIDNumber,
                                 java.lang.String strCheckDigit,
                                 java.lang.String strCheckDigitScheme,
                                 HD objAssigningAuthority,
                                 java.lang.String strIdentifierTypeCode,
                                 HD objAssigningFacility,
                                 java.lang.String strEffectiveDate,
                                 java.lang.String strExpirationDate,
                                 CWE objAssigningJurisdiction,
                                 CWE objAssigningAgencyOrDepartment,
                                 java.lang.String strSecurityCheck,
                                 java.lang.String strSecurityCheckScheme)

      Set the Sponsor Patient ID. This field contains the main patient identification for the study.
      Parameters:
        `strIDNumber` - Specifies the value of the identifier itself.
        `strCheckDigit` - It is part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Contains the code identifying the check digit scheme employed. Suggested Values NP,ISO,M10,M11.[Refer table No.0061].
        `objAssigningAuthority` - The assigning authority is a unique name of the system (or organization or agency or department) that creates the data. .
        `strIdentifierTypeCode` - Specifies a code corresponding to the type of identifier.In some cases, this code may be used as a qualifier to the "Assigning authority" component.[Refer table No 0203]
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the patient.
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepartment` - Specifies agency or department that assigned the identifier.
        `strSecurityCheck` - is used to communicate the version code.
        `objSecurityCheckSCheme` - is used to transmit information intended to validate veracity of the supplied identifier

    - #### setSponsorPatientID

          public void setSponsorPatientID(CX objsponsorPatientID)

      Set the Sponsor Patient ID. This field contains the main patient identification for the study.
      Parameters:
        `objsponsorPatientID` - Object of Sponsor Patient ID.

    - #### setSponsorStudyID

          public void setSponsorStudyID(java.lang.String strEntityIdentifier,
                               java.lang.String strNamespaceId,
                               java.lang.String strUniversalId,
                               java.lang.String strUniversalIdType)

      Set the Sponsor Study ID. This field contains the universal identifier for the clinical trial.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setSponsorStudyID

          public void setSponsorStudyID(EI objsponsorStudyID)

      Set the Sponsor Study ID. This field contains the universal identifier for the clinical trial.
      Parameters:
        `objsponsorStudyID` - Object of Sponsor Study ID.

    - #### addStratumforStudyRandomization

          public void addStratumforStudyRandomization(java.lang.String strIdentifier,
                                             java.lang.String strText,
                                             java.lang.String strNameOfCodingSystem,
                                             java.lang.String strAlternateIdentifier,
                                             java.lang.String strAlternateText,
                                             java.lang.String strNameOfAlternateCodingSystem,
                                             java.lang.String strCodingSystemVersionID,
                                             java.lang.String strAlternateCodingSystemVersionId,
                                             java.lang.String strOriginalText,
                                             java.lang.String strSecondAlternateIdentifier,
                                             java.lang.String strSecondAlternateText,
                                             java.lang.String strNameofSecondAlternateCodingSystem,
                                             java.lang.String strSecondAlternateCodingSystemVersionID,
                                             java.lang.String strCodingSystemOID,
                                             java.lang.String strValueSetOID,
                                             java.lang.String strValueSetVersionID,
                                             java.lang.String strAlternateCodingSystemOID,
                                             java.lang.String strAlternateValueSetOID,
                                             java.lang.String strAlternateValueSetVersionID,
                                             java.lang.String strSecondAlternateCodingSystemOID,
                                             java.lang.String strSecondAlternateValueSetOID,
                                             java.lang.String strSecondAlternateValueSetVersionID)

      Add the Stratum for Study Randomization.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addStratumforStudyRandomization

          public void addStratumforStudyRandomization(CWE objstratumforStudyRandomization)

      Add the Stratum for Study Randomization.
      Parameters:
        `objstratumforStudyRandomization` - Object of Stratum for Study Randomization.

    - #### setStratumforStudyRandomization

          public void setStratumforStudyRandomization(ISingleCollection<CWE> objstratumforStudyRandomizationList)

      Set the Stratum for Study Randomization.
      Parameters:
        `objstratumforStudyRandomizationList` - List of Stratum for Study Randomization.

    - #### addStudyAuthorizingProvider

          public void addStudyAuthorizingProvider(java.lang.String strIDNumber,
                                         FN objFamilyName,
                                         java.lang.String strGivenName,
                                         java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                         java.lang.String strSuffix,
                                         java.lang.String strPrefix,
                                         CWE objSourceTable,
                                         HD objAssigningAuthority,
                                         java.lang.String strNameTypeCode,
                                         java.lang.String strIdentifierCheckDigit,
                                         java.lang.String strCheckDigitScheme,
                                         java.lang.String strIdentifierTypeCode,
                                         HD objAssigningFacility,
                                         java.lang.String strNameRepresentationCode,
                                         CWE objNameContext,
                                         java.lang.String strNameAssemblyOrder,
                                         java.lang.String strEffectiveDate,
                                         java.lang.String strExpirationDate,
                                         java.lang.String strProfessionalSuffix,
                                         CWE objAssigningJurisdiction,
                                         CWE objAssigningAgencyOrDepratment,
                                         java.lang.String strSecurityCheck,
                                         java.lang.String strSecurityCheckScheme)

      Add the Study Authorizing Provider. This field contains the healthcare provider, generally the attending physician, who is accountable that the patient is eligible for the trial and have signed an informed consent.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### addStudyAuthorizingProvider

          public void addStudyAuthorizingProvider(XCN objstudyAuthorizingProvider)

      Add the Study Authorizing Provider. This field contains the healthcare provider, generally the attending physician, who is accountable that the patient is eligible for the trial and have signed an informed consent.
      Parameters:
        `objstudyAuthorizingProvider` - Object of Study Authorizing Provider.

    - #### setStudyAuthorizingProvider

          public void setStudyAuthorizingProvider(ISingleCollection<XCN> objstudyAuthorizingProviderList)

      Set the Study Authorizing Provider. This field contains the healthcare provider, generally the attending physician, who is accountable that the patient is eligible for the trial and have signed an informed consent.
      Parameters:
        `objstudyAuthorizingProviderList` - List of Study Authorizing Provider.

    - #### addStudyRandomizationDatetime

          public void addStudyRandomizationDatetime(java.lang.String strTime)

      Add the Study Randomization Date time. This field contains the date the patient is randomize.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### addStudyRandomizationDatetime

          public void addStudyRandomizationDatetime(DTM studyRandomizationDatetime)

      Add the Study Randomization Date time. This field contains the date the patient is randomize.
      Parameters:
        `studyRandomizationDatetime` - Object of Study Randomization Date time.

    - #### setStudyRandomizationDatetime

          public void setStudyRandomizationDatetime(ISingleCollection<DTM> studyRandomizationDatetimeList)

      Set the Study Randomization Date time. This field contains the date the patient is randomize.
      Parameters:
        `studyRandomizationDatetimeList` - List of Study Randomization Date time.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Thrown when Segment Validation Fails.